<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Algorithm_Lateral &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Algorithm_Longitudinal" href="algorithm_longitudinal.html" />
    <link rel="prev" title="Component View" href="../20_components.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4 current"><a class="current reference internal" href="#">Algorithm_Lateral</a></li>
<li class="toctree-l4"><a class="reference internal" href="algorithm_longitudinal.html">Algorithm_Longitudinal</a></li>
<li class="toctree-l4"><a class="reference internal" href="driver.html">Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_regular_driving.html">Dynamics_RegularDriving</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_scenario.html">Dynamics_Scenario</a></li>
<li class="toctree-l4"><a class="reference internal" href="sensor_driver.html">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4"><a class="reference internal" href="vehicle.html">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">Algorithm_Lateral</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/algorithm_lateral.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="algorithm-lateral">
<span id="id1"></span><h1>Algorithm_Lateral<a class="headerlink" href="#algorithm-lateral" title="Link to this heading"></a></h1>
<p>This module is responsible for the control of the vehicle’s lateral behavior.
It converts the lateral input of the driver module into a steering wheel angle.
The steering wheel angle can then be forwarded to a vehicle dynamics
module like <a class="reference internal" href="dynamics_regular_driving.html#dynamics-regular-driving"><span class="std std-ref">Dynamics_RegularDriving</span></a>.</p>
<section id="detailed-description-of-the-module-s-features">
<span id="algorithm-lateral-detailed-description"></span><h2>Detailed description of the module’s features<a class="headerlink" href="#detailed-description-of-the-module-s-features" title="Link to this heading"></a></h2>
<p>Algorithm_Lateral receives its command variables from a driver behavior model (or an ADAS)
and generates the steering wheel angle of the driver to match these command
variables. The steering wheel angle parts of all controllers are summed up to
the overall steering wheel angle of the driver, which is then sent to a vehicle
dynamics module like <a class="reference internal" href="dynamics_regular_driving.html#dynamics-regular-driving"><span class="std std-ref">Dynamics_RegularDriving</span></a>.
The control loop is closed by the movement of the vehicle in the world, which is
again monitored by the driver behavior model. This overall control loop of
vehicle lateral guidance involving Algorithm_Lateral is illustrated in the following image with the following variables:</p>
<ul class="simple">
<li><p><img class="math" src="../../../_images/math/6518029864d4abe20f5624f84c2a3fb5395f5818.png" alt="\kappa_{act}"/> is the actual curvature of the vehicle</p></li>
</ul>
<p>Four variables containing the information needed for the open-loop controller:</p>
<ul class="simple">
<li><p><img class="math" src="../../../_images/math/8ce6de673fb0a26f7371d24364b5f17956e817a3.png" alt="\kappa_{road}"/> is the curvature at the front center (i.e. center of the front of the bounding box) of the ego vehicle. It uses the vectors:</p></li>
<li><p><img class="math" src="../../../_images/math/585c10b7760635a294104d6bd75b446fa33f7520.png" alt="\kappa_{segment,near}"/> containing the curvatures of several segments starting at the front center up to 2m in front of the vehicles leading edge</p></li>
<li><p><img class="math" src="../../../_images/math/168469930df4357c57d598d42925d3e75db7cc85.png" alt="\kappa_{segment,far}"/> containing the curvatures of several segments starting 2m in front of the vehicle and ending 8m in front of it</p></li>
<li><p><img class="math" src="../../../_images/math/7fc672839ad28bec4b6ad1b6ad9bbb10d1b2e587.png" alt="\kappa_{manoeuvre}"/> containing the curvature of the planned trajectory relative to the road</p></li>
</ul>
<p>Other variables:</p>
<ul class="simple">
<li><p><img class="math" src="../../../_images/math/a87531a368534c59bdc44fbd82f53e9967bebf35.png" alt="w_{act}"/> is the actual lateral position of the vehicle in the road coordinate system</p></li>
<li><p><img class="math" src="../../../_images/math/6450616b75212cb568e905db49efd0c3dd584648.png" alt="\Delta"/> w is the lateral deviation</p></li>
<li><p><img class="math" src="../../../_images/math/c3718c9d15cbad369164f65b0083453db6089390.png" alt="\phi_{act}"/> is the actual heading angle of the vehicle in the road coordinate system</p></li>
<li><p><img class="math" src="../../../_images/math/6450616b75212cb568e905db49efd0c3dd584648.png" alt="\Delta"/><img class="math" src="../../../_images/math/fffd2357ee88a9c50ba9e831ed64c39c73d54a07.png" alt="\phi"/> is the heading error</p></li>
<li><p><img class="math" src="../../../_images/math/a7af2094ee9c485678dd97bfa42a308fb4ad0292.png" alt="\delta_{h,\kappa}"/> is the steering wheel angle from the curvature controller</p></li>
<li><p><img class="math" src="../../../_images/math/13166f7ebafb0f4497af4a92e7b579190b3f49ed.png" alt="\delta_{h,w}"/> is the steering wheel angle from the lateral deviation controller</p></li>
<li><p><img class="math" src="../../../_images/math/34b6c151daffc3c434e429cf7780d55e2c7b7524.png" alt="\delta_{h,\phi}"/> is the steering wheel angle from the heading error controller</p></li>
<li><p><img class="math" src="../../../_images/math/0e4c7fe45a4aa57ff07fcd90cc3e144dad9bb183.png" alt="\delta_h"/> is the overall steering wheel angle of the driver</p></li>
</ul>
<figure class="align-default" id="id2">
<span id="image-lateralcontrollersignalflow"></span><img alt="Components and signal flow of the lateral guidance control loop" src="../../../_images/LateralControllerSignalFlow.png" />
<figcaption>
<p><span class="caption-text">Components and signal flow of the lateral guidance control loop</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>The following subsections describe the theoretical background and the transfer
functions of the different controllers.</p>
<section id="lateral-dynamics">
<span id="algorithm-lateral-detailed-description-lateral-dynamics"></span><h3>Lateral dynamics<a class="headerlink" href="#lateral-dynamics" title="Link to this heading"></a></h3>
<p>The lateral dynamics model is based on the Ackermann model which is a simple geometric
expression for the relationship between the steering angle at the front wheels and
the curvature the vehicle produces from it. It has several simplifications, where
the most notable is the reduction of the wheels of one axle to a single surrogate
wheel. This is suitable under the consideration that the steering angles of the front
wheels are rather small and do not differ much between the left and the right
front wheel. The first simplification may not hold up in city traffic with high
curvatures. Therefore the closed-loop-controller must have increased gains in
these situations. <img class="math" src="../../../_images/math/8ce6de673fb0a26f7371d24364b5f17956e817a3.png" alt="\kappa_{road}"/>, <img class="math" src="../../../_images/math/585c10b7760635a294104d6bd75b446fa33f7520.png" alt="\kappa_{segment,near}"/> and <img class="math" src="../../../_images/math/168469930df4357c57d598d42925d3e75db7cc85.png" alt="\kappa_{segment,far}"/> are smoothed and weighted before adding <img class="math" src="../../../_images/math/7fc672839ad28bec4b6ad1b6ad9bbb10d1b2e587.png" alt="\kappa_{manoeuvre}"/> to form <img class="math" src="../../../_images/math/66aaf332fffda2edd545312fae414f1008ac96e7.png" alt="\kappa_{target}"/>.</p>
<p>The Ackermann model is illustrated in the following image with the following variables:</p>
<ul class="simple">
<li><p><img class="math" src="../../../_images/math/470aa65888a2971c9346e573f12b37ea406b8ec9.png" alt="l"/> is the wheelbase of the vehicle</p></li>
<li><p><img class="math" src="../../../_images/math/652b9d8b65c10aed0fdcdbde47396c879ed5bd33.png" alt="\delta"/> is the surrogate steering angle at the front wheels towards the vehicle’s longitudinal axis</p></li>
<li><p><img class="math" src="../../../_images/math/4abba779877abb276b98ccb2b4ba9bf2e41947ab.png" alt="M"/> is the instantaneous centre of rotation, around which the vehicle is driving on a curve</p></li>
<li><p><img class="math" src="../../../_images/math/79a3d439d28652c547386f39b555d90d3aaf102d.png" alt="r"/> is the radius of the curve, which the vehicle is driving around M</p></li>
<li><p><img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> is the curvature of this curve, which is simply the inverse of r</p></li>
</ul>
<figure class="align-default" id="id3">
<span id="image-ackermannmodel"></span><img alt="Illustration of the Ackermann model" src="../../../_images/AckermannModel.svg" /><figcaption>
<p><span class="caption-text">Illustration of the Ackermann model</span><a class="headerlink" href="#id3" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>In accordance to the current definitions of <a class="reference internal" href="../../../advanced_topics/simulator/coordinate_systems.html#coordinatesystems"><span class="std std-ref">coordinate systems</span></a>,
the coordinate reference point of the vehicle is considered to be the rear axle center.
Therefore, the curvature of the vehicle is also expressed towards the rear axle center
and not to the centre of gravity, which is why the centre of gravity is not
depicted in illustration of the Ackermann model.</p>
<p>The equation derived from the Ackermann model states the following
relation between the surrogate steering angle <img class="math" src="../../../_images/math/652b9d8b65c10aed0fdcdbde47396c879ed5bd33.png" alt="\delta"/> of the front wheels and
the curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> described by the rear axle around the instantaneous
centre of rotation <img class="math" src="../../../_images/math/4abba779877abb276b98ccb2b4ba9bf2e41947ab.png" alt="M"/>:</p>
<div class="math">
<p><img src="../../../_images/math/74f92e086f237d26ce895805a75a3794a20ea231.png" alt="\kappa = \frac{\tan(\delta)}{l}"/></p>
</div><p>This equation can be inverted to express a required steering angle <img class="math" src="../../../_images/math/652b9d8b65c10aed0fdcdbde47396c879ed5bd33.png" alt="\delta"/> to
adjust a specific curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/>:</p>
<div class="math">
<p><img src="../../../_images/math/904ab3c787fc37ec90b00ea39276b005b3e68bb5.png" alt="\delta = \arctan(\kappa \cdot l)"/></p>
</div><p>To convert this into the required steering wheel angle <img class="math" src="../../../_images/math/a7af2094ee9c485678dd97bfa42a308fb4ad0292.png" alt="\delta_{h,\kappa}"/>,
the ratio <img class="math" src="../../../_images/math/bb5c6a531ccc8353d7d7634bf0aa0f50b23f0219.png" alt="i_s"/> of the steering gear must be applied:</p>
<div class="math">
<p><img src="../../../_images/math/14b20bf4e45cb8ae2ffce20e998b6a3ca46e840a.png" alt="\delta_{h, \kappa} = i_{s} \cdot \arctan(\kappa \cdot l)"/></p>
</div><p>The vehicle parameters <img class="math" src="../../../_images/math/470aa65888a2971c9346e573f12b37ea406b8ec9.png" alt="l"/> and <img class="math" src="../../../_images/math/bb5c6a531ccc8353d7d7634bf0aa0f50b23f0219.png" alt="i_s"/> are received from the module <a class="reference internal" href="../../../advanced_topics/simulator/agent_components.html#parameters-vehicle"><span class="std std-ref">Parameters_Vehicle</span></a>.</p>
</section>
<section id="heading-controller">
<span id="algorithm-lateral-detailed-description-control-heading"></span><h3>Heading controller<a class="headerlink" href="#heading-controller" title="Link to this heading"></a></h3>
<p>The heading controller is designed as a simple proportional controller.
The general transfer function of a P-controller with the input signal heading
error <img class="math" src="../../../_images/math/bf31fd4198da89cf275d011551e51296f3a25d00.png" alt="\Delta\phi"/> and the output signal steering wheel angle <img class="math" src="../../../_images/math/34b6c151daffc3c434e429cf7780d55e2c7b7524.png" alt="\delta_{h,\phi}"/>
is described as:</p>
<div class="math">
<p><img src="../../../_images/math/cf5d091b6daa2ea077ca19f44565e74767adda6e.png" alt="\delta_{h, \phi} = P_{\phi} \cdot \Delta\phi"/></p>
</div><p>The controller amplification <img class="math" src="../../../_images/math/a82e01dd8bc821dfd613dc692b08dea66c30cc61.png" alt="P_\phi"/> is therefore described as the
ratio between input signal and output signal:</p>
<div class="math">
<p><img src="../../../_images/math/588e3c29e58ff6acec4d2f476bba2e3cf19cc6d1.png" alt="P_{\phi} = \frac{\delta_{h,\phi}}{\Delta\phi}"/></p>
</div><p>The controller amplification <img class="math" src="../../../_images/math/a82e01dd8bc821dfd613dc692b08dea66c30cc61.png" alt="P_\phi"/> therefore expresses, how many
degrees of steering wheel angle are generated by one degree heading error.
The design of this controller amplification <img class="math" src="../../../_images/math/a82e01dd8bc821dfd613dc692b08dea66c30cc61.png" alt="P_\phi"/> uses some
considerations about plane driving kinematics of Kramer. First of all,
the heading error <img class="math" src="../../../_images/math/bf31fd4198da89cf275d011551e51296f3a25d00.png" alt="\Delta\phi"/> is derived from the current curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/>
of the vehicle over the change of distance <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> along the road’s longitudinal
coordinate <img class="math" src="../../../_images/math/106b04b320e75010b1d8029e59244f234f75e6f9.png" alt="s"/> in one time step:</p>
<div class="math">
<p><img src="../../../_images/math/1a04e3412abf6eed6165fce1b7d460421afa185e.png" alt="\Delta\phi = \arctan(ds \cdot \kappa)"/></p>
</div><p>Under the consideration of small angular changes in one time step, this equation
can be linearized to:</p>
<div class="math">
<p><img src="../../../_images/math/2d48e4c353f1c41600a444603df02ebd159cfff1.png" alt="\Delta\phi = ds \cdot \kappa"/></p>
</div><p>The curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> of the vehicle can be substituted by an Ackermann model
(see <a class="reference internal" href="#algorithm-lateral-detailed-description-lateral-dynamics"><span class="std std-ref">here</span></a> for further information about that):</p>
<div class="math">
<p><img src="../../../_images/math/856869e75917b044aa8e0e982f4414465cfa0f22.png" alt="\Delta\phi = \frac{ds \cdot \tan(\delta)}{l}"/></p>
</div><p>This equation can also be linearized under the consideration of small angles:</p>
<div class="math">
<p><img src="../../../_images/math/725343a4b4a6b031052db49cb018677a66c5e25e.png" alt="\Delta\phi = \frac{ds \cdot \delta} {l}"/></p>
</div><p>The connection to the steering wheel angle <img class="math" src="../../../_images/math/34b6c151daffc3c434e429cf7780d55e2c7b7524.png" alt="\delta_{h,\phi}"/> can be
applied by the ratio <img class="math" src="../../../_images/math/bb5c6a531ccc8353d7d7634bf0aa0f50b23f0219.png" alt="i_s"/> of the vehicle’s steering gear:</p>
<div class="math">
<p><img src="../../../_images/math/1dcaca69c0023651d4af1872cdaa4941ebafe8a0.png" alt="\Delta\phi = \frac{ds \cdot \delta_{h,\phi}}{i_s \cdot l}"/></p>
</div><p>This equation can be transformed to a similar form as the controller’s transfer
function above:</p>
<div class="math">
<p><img src="../../../_images/math/e49e1b153e930b69af4898fad5114387416a72ab.png" alt="\frac{i_s \cdot l}{ds} = \frac{\delta_{h,\phi}}{\Delta\phi}"/></p>
</div><p>The usage of the incremental difference <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> in this equation is problematic,
because the controller amplification becomes dependent on the simulation step
size. Because of this, the absolute change <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> of the longitudinal road
coordinate <img class="math" src="../../../_images/math/106b04b320e75010b1d8029e59244f234f75e6f9.png" alt="s"/> is substituted by the vehicle’s absolute velocity <img class="math" src="../../../_images/math/02d98909b5d6acd6a7ff927d4d42790bdd407d58.png" alt="v"/> as a
simplification, which is the change of travelled distance with respect to time:</p>
<div class="math">
<p><img src="../../../_images/math/0d84fa1cff0096a1b50c9bcbbc29f1e2019ed503.png" alt="\frac{i_s \cdot l}{v} = \frac{\delta_{h,\phi}}{\Delta\phi}"/></p>
</div><p>To tune the absolute influence of the heading controller in the overall control
loop, an additional gain factor <img class="math" src="../../../_images/math/b2190f7743a598eb45240597d6fda86d9da74190.png" alt="\text{Gain}_{\Delta\phi}"/> is applied to this
transfer function, which allows a situation dependent amplification of the
heading controller by the driver behavior model:</p>
<div class="math">
<p><img src="../../../_images/math/489c522ced5a8dbad18b3b7964d5cd24d9742a91.png" alt="\delta_{h,\phi} = \frac{\text{Gain}_{\Delta\phi} \cdot i_s \cdot l \cdot \Delta\phi}{v}"/></p>
</div><p>The vehicle parameters <img class="math" src="../../../_images/math/470aa65888a2971c9346e573f12b37ea406b8ec9.png" alt="l"/> and <img class="math" src="../../../_images/math/bb5c6a531ccc8353d7d7634bf0aa0f50b23f0219.png" alt="i_s"/> are received from the module <a class="reference internal" href="../../../advanced_topics/simulator/agent_components.html#parameters-vehicle"><span class="std std-ref">Parameters_Vehicle</span></a>, the vehicle’s
absolute velocity <img class="math" src="../../../_images/math/02d98909b5d6acd6a7ff927d4d42790bdd407d58.png" alt="v"/> is received from the module <a class="reference internal" href="sensor_driver.html#sensor-driver"><span class="std std-ref">Sensor_Driver</span></a>,
and the additional controller gain <img class="math" src="../../../_images/math/b2190f7743a598eb45240597d6fda86d9da74190.png" alt="\text{Gain}_{\Delta\phi}"/> is received from
a driver behavior model.</p>
</section>
<section id="lateral-deviation-controller">
<span id="algorithm-lateral-detailed-description-control-deviation"></span><h3>Lateral deviation controller<a class="headerlink" href="#lateral-deviation-controller" title="Link to this heading"></a></h3>
<p>The lateral deviation controller is designed as a simple proportional controller. The general transfer
function of a P-controller with the input signal lateral deviation <img class="math" src="../../../_images/math/6450616b75212cb568e905db49efd0c3dd584648.png" alt="\Delta"/> w and
the output signal steering wheel angle <img class="math" src="../../../_images/math/13166f7ebafb0f4497af4a92e7b579190b3f49ed.png" alt="\delta_{h,w}"/> is described as:</p>
<div class="math">
<p><img src="../../../_images/math/86eaaff22e13f4174c0d4d1f3736ec90803361f4.png" alt="\delta_{h,w} = P_w \cdot \Delta w"/></p>
</div><p>The controller amplification <img class="math" src="../../../_images/math/484e7616c268495d07025ea1cf4ebb24171e77c7.png" alt="P_w"/> is therefore described as the ratio
between input signal and output signal:</p>
<div class="math">
<p><img src="../../../_images/math/21a69a1aceb85e2ee86e1036e83dec988ff98402.png" alt="P_w = \frac{\delta_{h,w}}{\Delta w}"/></p>
</div><p>The controller amplification <img class="math" src="../../../_images/math/484e7616c268495d07025ea1cf4ebb24171e77c7.png" alt="P_w"/> therefore expresses, how many degrees
of steering wheel angle are generated by one metre of lateral deviation. The
design of this controller amplification <img class="math" src="../../../_images/math/484e7616c268495d07025ea1cf4ebb24171e77c7.png" alt="P_w"/> uses some considerations
about plane driving kinematics of Kramer. First of all, the lateral deviation
<img class="math" src="../../../_images/math/6450616b75212cb568e905db49efd0c3dd584648.png" alt="\Delta"/> w is derived from the current heading error <img class="math" src="../../../_images/math/bf31fd4198da89cf275d011551e51296f3a25d00.png" alt="\Delta\phi"/> over the change
of distance <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> along the road’s longitudinal coordinate <img class="math" src="../../../_images/math/106b04b320e75010b1d8029e59244f234f75e6f9.png" alt="s"/> in one time step:</p>
<div class="math">
<p><img src="../../../_images/math/d4190ba7429fdd1c6cf50299b566af22c8ed672f.png" alt="\Delta w = ds \cdot \sin(\Delta\phi)"/></p>
</div><p>The current heading error <img class="math" src="../../../_images/math/bf31fd4198da89cf275d011551e51296f3a25d00.png" alt="\Delta\phi"/> can further be substituted by an
expression of <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> and the current curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> of the vehicle
(see <a class="reference internal" href="#algorithm-lateral-detailed-description-control-heading"><span class="std std-ref">Heading controller</span></a> for that matter):</p>
<div class="math">
<p><img src="../../../_images/math/9c7d8ba576ddb3e01656bf636a58d5e2382c4788.png" alt="\Delta w = ds \cdot \sin(\arctan(ds \cdot \kappa))"/></p>
</div><p>Under the consideration of small angular changes in one time step, this equation
can be linearized to:</p>
<div class="math">
<p><img src="../../../_images/math/0544af86fdc3b9b8f5a1fea42686284440f173f8.png" alt="\Delta w = ds^2 \kappa"/></p>
</div><p>The curvature <img class="math" src="../../../_images/math/261e3eb56c1757dd003745ee4cc53aa595565af1.png" alt="\kappa"/> of the vehicle can be substituted by an Ackermann model
(see <a class="reference internal" href="#algorithm-lateral-detailed-description-lateral-dynamics"><span class="std std-ref">here</span></a> for further information about that):</p>
<div class="math">
<p><img src="../../../_images/math/3745c79b180584a6eeb7a00c99f368fe9d492240.png" alt="\Delta w = \frac{ds^2 \tan(\delta)}{l}"/></p>
</div><p>This equation can also be linearized under the consideration of small angles:</p>
<div class="math">
<p><img src="../../../_images/math/9b21a89980776281905e30c1175c2214b020c092.png" alt="\Delta w = \frac{ds^2 \cdot \delta}{l}"/></p>
</div><p>The connection to the steering wheel angle <img class="math" src="../../../_images/math/13166f7ebafb0f4497af4a92e7b579190b3f49ed.png" alt="\delta_{h,w}"/> can be applied
by the ratio <img class="math" src="../../../_images/math/bb5c6a531ccc8353d7d7634bf0aa0f50b23f0219.png" alt="i_s"/> of the vehicle’s steering gear:</p>
<div class="math">
<p><img src="../../../_images/math/6b345baca88677dd399e4879c447a2fdb47b10c4.png" alt="\Delta w = \frac{ds^2 \cdot \delta_{h,w}}{i_s \cdot l}"/></p>
</div><p>This equation can be transformed to a similar form as the controller’s transfer
function above:</p>
<p>The usage of the incremental difference <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> in this equation is problematic,
because the controller amplification becomes dependent on the simulation step
size. Because of this, the absolute change <img class="math" src="../../../_images/math/f5b7a2e0152ed016dacfb6dcb49e6385dd2c3777.png" alt="ds"/> of the longitudinal road
coordinate <img class="math" src="../../../_images/math/106b04b320e75010b1d8029e59244f234f75e6f9.png" alt="s"/> is substituted by the vehicle’s absolute velocity <img class="math" src="../../../_images/math/02d98909b5d6acd6a7ff927d4d42790bdd407d58.png" alt="v"/> as a
simplification, which is the change of travelled distance with respect to time:</p>
<p>To tune the absolute influence of the lateral deviation controller in the
overall control loop, an additional gain factor <img class="math" src="../../../_images/math/ddfbf6a6a84d5e2ff415036fa6eb26813f6cdf8a.png" alt="\text{Gain}_{\Delta w}"/> is
applied to this transfer function, which allows a situation dependent
amplification of the lateral deviation controller by the driver behavior model:</p>
<div class="math">
<p><img src="../../../_images/math/e5965741d2e47ebcac151ffa85aa7513a872af23.png" alt="\delta_{h,w} = \frac{\text{Gain}_{\Delta w} \cdot i_s \cdot l \cdot \Delta w}{v^2}"/></p>
</div><p>The vehicle parameters <img class="math" src="../../../_images/math/470aa65888a2971c9346e573f12b37ea406b8ec9.png" alt="l"/> and <img class="math" src="../../../_images/math/bb5c6a531ccc8353d7d7634bf0aa0f50b23f0219.png" alt="i_s"/> are received from the module <a class="reference internal" href="../../../advanced_topics/simulator/agent_components.html#parameters-vehicle"><span class="std std-ref">Parameters_Vehicle</span></a>, the vehicle’s
absolute velocity <img class="math" src="../../../_images/math/02d98909b5d6acd6a7ff927d4d42790bdd407d58.png" alt="v"/> is received from the module <a class="reference internal" href="sensor_driver.html#sensor-driver"><span class="std std-ref">Sensor_Driver</span></a>,
and the additional controller gain <img class="math" src="../../../_images/math/ddfbf6a6a84d5e2ff415036fa6eb26813f6cdf8a.png" alt="\text{Gain}_{\Delta w}"/> is received from a
driver behavior model.</p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../20_components.html" class="btn btn-neutral float-left" title="Component View" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="algorithm_longitudinal.html" class="btn btn-neutral float-right" title="Algorithm_Longitudinal" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>